# calc-ultra

[![MIT License](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/license/mit/) [![Version](https://img.shields.io/badge/Version-1.3.5-blue.svg)](https://github.com/sudoer-Huatao/calc_ultra)

> **Calculus made easy**

(Turn on dark mode for a better aesthetic) 📲

Calc-Ultra is a multi-functional calculator that uses command line interfaces. Little Python background knowledge is needed to use the calculator!

Supports:

- Derivatives
- Partials
- Implicit differentiation
- Limits
- Antiderivatives
- Definite integrals
- Improper integrals
- Double integrals
- Solving (sets) of equation(s)
- Vector/matrix operations
- **A perfect interface to do calculations!**  

## Chinese version

Want to check out the Chinese version? Visit <https://github.com/sudoer-Huatao/calc_ultra-chinese>! 🇨🇳

## Installation and Running

> Run the calculus calculator with a single line of code

Use the following command to download Calc-Ultra (pip should be installed):

`pip3 install calc-ultra`

Due to Python import identifiers restrictions, please import Calc-Ultra as "calc_ultra" and not "calc-ultra".

Import Calc-Ultra like so to use:

`from calc_ultra import main`

Please make sure you have the latest version installed. To update calc-ultra, run the following command:

`pip3 install --upgrade calc-ultra`

## Requirements

Calc-Ultra requires these modules/packages:

- `sympy`
- `numpy`
- `matplotlib`
- `scipy`
- `rich`
- `prompt-toolkit`

If you do not have them installed, there is no need to worry. The modules needed should be installed automatically if you don't have them. Other required modules are built into most Python IDEs as well.

## Test PYPI

Previous test versions of this project are on Test PYPI. View on <https://test.pypi.org/project/calc-ultra/>. 💾

## Acknowledgements

> Without them, this would be impossible

A big thank-you to all GitHub users who gave feedback and/or starred this repository. ⭐️ Your encouragement is our motivation.
The following contributors deserve a SPECIAL THANK-YOU 👍❤️:

- @Haobot for troubleshooting and feedback!
- Fanbo for feedback and ideas for improvement!

This program was made using `sympy` for calculation and `numpy`, `scipy`, and `matplotlib` for graphing.

## Gallery (Demos)

DerivaCalc derivative with graph demo:
![derivacalc_demo](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/3d99a51d-2e46-414c-8929-fa16016a856a "derivacalc_demo")

InteCalc antiderivative with graph demo:
![intecalc_demo_1](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/f61d44ae-cebf-4972-b63f-7f08ee6655b5 "intecalc_demo_1")

InteCalc definite integral with graph demo:
![intecalc_demo_2](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/b8294186-92f5-4df3-a000-d63f6fff93b0 "intecalc_demo_2")

LimCalc limit demo:
![limcalc_demo](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/12db6a7b-a836-43ce-8cef-7bcf707051f7 "limcalc_demo")

AlgCalc equation solver demo:
![algcalc_demo_1](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/e4cfa016-52bf-43b5-a839-af9f42546468 "algcalc_demo_1")

AlgCalc vector operation demo:
![algcalc_demo_2](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/7f043cb2-6b0a-4460-ab35-30f09632b1c3 "algcalc_demo_2")

AlgCalc matrix operation demo:
![algcalc_demo_3](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/a9a5d56e-424a-4ef8-beb9-a9b64ce1a3f5 "algcalc_demo_3")

## License

This project is licensed under the terms of the MIT license.
